import type { Bud } from '@roots/bud-framework';
import type { AsyncCallback, AsyncRegistry, AsyncStore } from '@roots/bud-framework/registry';
import { Hooks } from '../base/base.js';
/**
 * Asynchronous hooks registry
 */
export declare class AsyncHooks extends Hooks<AsyncStore> {
    /**
     * Get a value
     */
    get<T extends keyof AsyncRegistry & string>(id: T, fallback?: AsyncRegistry[T]): Promise<AsyncRegistry[T]>;
    /**
     * Set a value
     */
    set<T extends keyof AsyncStore & string>(id: T, ...input: AsyncCallback[T]): Bud;
    /**
     * Set multiple values
     */
    setRecords(map: Partial<AsyncCallback>): Bud;
}
