import type { Bud } from '@roots/bud-framework';
/**
 * Synchronous hooks registry
 *
 * @remarks
 * Supports sync values
 */
export declare abstract class Hooks<Store> {
    _app: () => Bud;
    /**
     * Hooks store
     */
    store: Store;
    /**
     * Class constructor
     */
    constructor(_app: () => Bud);
    /**
     * Get app
     */
    get app(): Bud;
    /**
     * Get logger
     */
    get logger(): import("@roots/bud-support/logger").Logger;
    catch(e: Error, id?: string, iteration?: number): never;
    /**
     * Check if a hook has been set somewhere
     */
    has<T extends keyof Store & string>(path: T): boolean;
}
