import type { Bud } from '@roots/bud-framework';
import type { Events, EventsStore } from '@roots/bud-framework/registry';
import { Hooks } from '../base/base.js';
/**
 * Synchronous hooks registry
 *
 * @remarks
 * Supports sync values
 */
export declare class EventHooks extends Hooks<EventsStore> {
    get<T extends keyof Events & string>(id: T, ...value: Events[T]): Promise<Bud>;
    set<T extends keyof EventsStore & string>(id: T, ...input: Array<(...value: Events[T]) => Promise<unknown>>): Bud;
}
