import type { Bud } from '@roots/bud-framework';
import type { SyncCallback, SyncRegistry, SyncStore } from '@roots/bud-framework/registry';
import { Hooks } from '../base/base.js';
/**
 * Synchronous hooks registry
 */
export declare class SyncHooks extends Hooks<SyncStore> {
    /**
     * Get a value
     */
    get<T extends keyof SyncRegistry & string>(id: T, fallback?: SyncRegistry[T]): SyncRegistry[T];
    /**
     * Set a value
     */
    set<T extends `${keyof SyncStore & string}`>(id: T, ...input: Array<SyncCallback[T]>): Bud;
    /**
     * Set multiple values
     */
    setRecords(map: Partial<SyncCallback>): Bud;
}
