import { __decorate } from "tslib";
import { bind } from '@roots/bud-support/decorators/bind';
import isFunction from '@roots/bud-support/isFunction';
import Value from '@roots/bud-support/value';
import { Hooks } from '../base/base.js';
/**
 * Synchronous hooks registry
 */
export class SyncHooks extends Hooks {
    /**
     * Get a value
     */
    get(id, fallback) {
        return [Value.make(fallback), ...(this.store[id] ?? [])]
            .map(Value.get)
            .reduce((accumulated, current) => {
            return isFunction(current) ? current(accumulated) : current;
        });
    }
    /**
     * Set a value
     */
    set(id, ...input) {
        if (!this.has(id))
            this.store[id] = [];
        this.store[id].push(...input.flatMap(Value.make));
        return this.app;
    }
    /**
     * Set multiple values
     */
    setRecords(map) {
        Object.entries(map).map(([k, v]) => this.set(k, v));
        return this.app;
    }
}
__decorate([
    bind
], SyncHooks.prototype, "get", null);
__decorate([
    bind
], SyncHooks.prototype, "set", null);
__decorate([
    bind
], SyncHooks.prototype, "setRecords", null);
